; File Name   :	D:\user\pohlers\privat\hobby\lc80-morse\morse.bin
; Format      :	Binary file
; Base Address:	0000h Range: 2000h - 20FDh Loaded length: 00FDh
; Autor: Norbert Denkes, Funkamateur 1/86, S.29-30
; reass: V. Pohlers, 22.04.08

		cpu	z80

		include	lc80

		org 2000h

morse:		xor	a
		ld	hl, word_2314
		ld	de, word_2314+1
		ld	bc, 7
		ld	(hl), a
		ldir
;
		dec	de
		ldir
;
		ld	a, (ton)	; Tonhhe (01..FF, Std.	E0)
		cpl
		add	a, 5
		ld	(word_2314), a
;
		ld	a, (tempo)	; Gebegeschwindigkeit
		ld	(word_2316), a
;
		ld	hl, 0
		ld	de, (word_2314)
		ld	bc, (word_2316)
morse1:		dec	bc
		add	hl, de
		ld	a, c
		or	c
		jr	nz, morse1
;
		xor	a
		ex	de, hl
		ld	hl, 5050h
		ld	c, 3
morse2:		inc	a
		sbc	hl, de
		jr	nc, morse2
		push	de
		ld	de, 0FFFFh
		add	hl, de
		pop	de
		dec	c
		jr	nz, morse2
;
		ld	b, 0
		ld	c, a
		ld	(word_231A), bc
; gesamten Text ausgeben
morse3:		ld	hl, text	; Morsetext
; neue Fnfergruppe
morse4:		ld	b, 5
; ein Zeichen ausgeben
morse5:		ld	a, (hl)		; nchstes Zeichen holen
		ld	c, 8		; 8 Bit abarbeiten
morse6:		dec	c
		rlca
		jr	z, morse9	
		jr	nc, morse6	; Auffllbits (0) berspringen
; Trennbit gefunden
morse7:		rlca			; Trennbit bergehen
;
		push	hl
		push	bc
		push	af
		ld	hl, (word_231A)
		ld	a, (word_2314)
		ld	c, a
		jr	nc, morse8
		ld	de, (word_231A)
		add	hl, hl
		add	hl, de
morse8:		call	SOUND		; Tonsignalausgabe
		ld	a, (word_2314)
		ld	c, a
		ld	hl, (word_231A)
		call	wait2		; Pause zwischen einzelnen Bits
		pop	af
		pop	bc
		pop	hl
;
		dec	c		; alle 8 Bits fertig?
		jr	nz, morse7	; nein -> nchstes Bit abarbeiten
;
morse9:		push	hl
		push	bc
		push	de
		ld	a, (word_2314)
		ld	c, a
		ld	hl, (word_231A)
		call	wait1		; Pause zwischen einzelnen Zeichen (Normpause)
;alternativ	call	wait		; Pause zwischen einzelnen Zeichen (lngere Pause)
; Anzahl der bisher ausgegeben Zeichen um 1 erhhen
		ld	hl, word_2318	; Anzahl der bisher ausgegeben Zeichen
		ld	b, 0
		ld	a, (hl)
		add	a, 1
		daa
		ld	(hl), a
		inc	hl
		ld	a, (hl)
		adc	a, b
		daa
		ld	(hl), a
		pop	de
		pop	bc
		pop	hl
;
		inc	hl
		dec	b
		push	af
		ld	a, (hl)
		cp	0FFh		; Textende?
		jr	z, morse11
		pop	af
		jr	nz, morse5
		push	de
		push	hl
		push	bc
		ld	a, (word_2314)
		ld	c, a
		ld	hl, (word_231A)
		call	wait		; Pause zwischen Fnfergruppen
		pop	bc
		pop	hl
		pop	de
		ld	a, (stop5)	; Stop nach jeder Fnfergruppe (<> FF)
		cp	0FFh
		jr	z, morse4	; nein - weitermachen
morse10:	jr	z, morse3
		push	hl
		call	anz		; Anzeige der Zeichenanzahl
		pop	hl
		jr	morse4
; Textende
morse11:	ld	a, (stope)	; Stop nach dem	gesamten Text (FF)
		cp	0
		jr	z, morse10
		call	anz		; Anzeige der Zeichenanzahl
		jp	morse

;Anzeige
anz:		ld	de, (word_2318)	; Anzahl der bisher ausgegeben Zeichen
		call	ADRSDP 		; Eintragen von 4 Ziffern in Adressanz.speicher
		ld	ix, ADRLED	; Adressanzeige; Std-Anzeigespeicher
		call	DAK1 		; Anzeige bis Tastendruck
		ret

;Zeitschleife
;Pause zwischen Fnfergruppen
wait:		ld	de, (word_231A)
		add	hl, hl
		add	hl, hl
;Pause zwischen einzelnen Zeichen
wait1:		add	hl, hl
		add	hl, de
;Pause zwischen einzelnen Bits
wait2:		add	hl, hl
		ld	de, 1
wait3:		nop
		nop
		nop
		ld	b, c
wait4:		djnz	$
		sbc	hl, de
		jr	nz, wait3
		ret


		org	2100h
text:		equ	$		; Morsetext


		org	2310h

tempo:		ds 1			; Gebegeschwindigkeit
ton:		ds 1			; Tonhhe (01..FF, Std.	E0)
stop5:		ds 1			; Stop nach jeder Fnfergruppe (<> FF)
stope:		ds 1			; Stop nach dem	gesamten Text (FF)
word_2314:	ds 2			; 
word_2316:	ds 2			; 
word_2318:	ds 2			; Anzahl der bisher ausgegeben Zeichen
word_231A:	ds 2			; 

		end
