; Programm ???
; Schaltkreistester fr Zilosko-Hardware
; Autor: Volker Pohlers
; Version 07.09.03 11:02
;------------------------------------------------------------------------------
;
; Schaltkreistester fr TTL-Schaltkreise. Programm luft automatisch. Start ->
; Schaltkreis in Fassung -> Anzeige Typ. Bleibt die Anzeige dunkel, so Schaltkreis
; defekt oder nicht in Liste. Nchsten Schlatkreis einsetzen usw.
;
;
;         o   o   o   o   o   o   o
;	------------------------------
;	| +5V a4  a5  a6  a7  A3  A2 |
;	 )                           |
;	| b0  b1  b2  b3  a1  a0 Gnd |
;	------------------------------
;         o   o   o   o   o   o   o
;
; ber R=270 Ohm an PIO's
;
; s. "Hinweise zur Anwendung des Lerncomputers LC 80", Teil 1, Seite 63-76
; s.auch Funkamateur xx/xx
;
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h

anf:		ld	ix, tabelle
beg:		ld	a,(ix)
		or	a
		jr	z,anf			; bei Tabellenende
;
		ld	a, 0FFh			; PIO-Mode 3 Port A
		out	(PIO2AC),a
		ld	a, (ix)			; E/A-Definition Port A
		inc	ix
		out	(PIO2AC),a
		ld	a, 0FFh			; PIO-Mode 3 Port B
		out	(PIO2BC),a
		ld	a, (ix)			; E/A-Definition Port B
		inc	ix
		out	(PIO2BC),a
;
		ld	b, (ix)			; Schleifenzhler
		inc	ix
;
; Berechnung Anfang nchster IC
		push	ix
		pop	iy			; iy := aktuelle Position in Tabelle
		ld	d,0
		ld	e,b			; de := Anzahl Tests
		add	iy,de
		add	iy,de			; iy += 2*de
		ld	e,6
		add	iy,de			; iy += 6 (fr IC-Namen)
;
test:		ld	a, (ix)
		inc	ix
		ld	d, a
		out	(USERPORT),a		; Ausgabe gem. Wahrheitstabelle Port A
		ld	a, (ix)
		inc	ix
		ld	e, a
		out	(KEYIN),a		; Ausgabe gem. Wahrheitstabelle Port B
		in	a, (USERPORT)		; Einlesen und Ablegen in H, Port A
		ld	h, a
		in	a, (KEYIN)		; Einlesen und Ablegen in L, Port B
		ld	l, a
		or	a			; Cy = 0
		sbc	hl, de			; Subtraktion HL-DE
		jr	nz,nextic		; Bei Fehler
		djnz	test
;
		call	DAK2			; wenn alle Tests ok, Anzeige Typ
;
nextic:		push	iy			; berechnete Adresse nach ix
		pop	ix
		jp	beg
;
tabelle:
;
; Aufbau Tabelle: pro Schaltkreis
;    1 Byte E/A Definition Port A	1 = IS-Ausgang, 0 = IS-Eingang
;    1 Byte E/A Definition Port B
;    1 Byte Testanzahl
;    pro Test 2 Byte: Testbyte Port A und Testbyte Port B	= log. Pegel
;    6 Byte Schaltkreisname
; Tabellenende 00
;
;;D100D
;		db 045h,0F4h 			; Portfestlegung Port A, Port B
;		db 4 				; Anzahl der Tests 
;		db 045h,0F4h 			; 1. Test
;		db 0D7h,0F6h 			; 2. Test
;		db 06Dh,0FDh 			; 3. Test
;		db 0BAh,0FBh 			; 4. Test
;		db 000h,0E9h,0E7h,0E7h,021h,0E9h; "D100D "
;;D110D
;		db 025h,0F0h	
;		db  8	
;		db 025h,0F4h	
;		db 077h,0F0h	
;		db 0A5h,0FAh	
;		db 02Dh,0F5h	
;		db 0F7h,0FAh	
;		db 07Fh,0F5h	
;		db 0ADh,0FFh	
;		db 0DAh,0FFh	
;		db 000h,0E9h,0E7h,021h,021h,0E9h
;;D104D
;		db 0A5h,0FAh
;		db 2
;		db 0A5h,0FAh
;		db 05Ah,0F5h
;		db 000h,0E9h,02bh,0e7h,021h,0E9h
;;D174D
;		db 00fh,0F0h
;		db 0ah
;		db 085h,0f8h
;		db 01ah,0f1h
;		db 0e5h,0feh
;		db 01ah,0f1h
;		db 09ah,0f9h
;		db 0d5h,0fdh
;		db 0b5h,0fbh
;		db 0fah,0ffh
;		db 09ah,0f9h
;		db 0e5h,0feh
;		db 000h,0E9h,02bh,025h,021h,0E9h
;;V4001D
;		db 0c0h,0fch
;		db 4
;		db 0c0h,0fch
;		db 019h,0f2h
;		db 026h,0f1h
;		db 03fh,0f3h
;		db 0e9h,021h,0e7h,0e7h,02bh,0e3h
;;V4011D
;		db 0c0h,0fch
;		db 4
;		db 0c0h,0fch
;		db 0d9h,0feh
;		db 0e6h,0fdh
;		db 03fh,0f3h
;		db 0e9h,021h,021h,0e7h,02bh,0e3h
;;V4030D
;		db 0c0h,0fch
;		db 4
;		db 000h,0f0h
;		db 0d9h,0feh
;		db 0e6h,0fdh
;		db 03fh,0f3h
;		db 0e9h,0e7h,0adh,0e7h,02bh,0e3h
;;

		include	liste


		db 0

		end
