; Programm E004
; einfacher Taschenrechner
; Autor: ?
; auf LC-80 umgesetzt: Volker Pohlers
;
;------------------------------------------------------------------------------
; Einfacher Taschenrechner nach Poly-Computer Poly-880
; fr ganze, positive Zahlen <= 65535
; 
; Bedienung:
; 1. Zahl eingeben, "E" drcken
; 2. Zahl eingeben, Funktionstaste drcken
; "A"-Addition, "B"-Subtraktion, "C"-Multiplikation, "D"-Division, "E"-Eingabe, 
; "F"-frei fr Erweiterung
; bei unzulssiger Operation und Bereichsberschreitung Anzeige "error",
; mit beliebiger Taste lschen
; 1. Zahl ist Konstante (bleibt bei Rechnung erhalten, auer DIV)
; 
; Beispiel fr Quadrat-Funktion fr "F" s. Listingende
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h

start:		jp	tarech
;start:		jp	clear			; Erweiterung: Start mit 0
;
zahl:		push	de			; Anzeige X-Wert
		push	hl			; (Hex-Dez Konvertierung)
		call	loanz
		ld	a,5
zahl1:		ld	bc,10
		ld	de,0ffffh
zahl2:		inc	de
		and	a			; Cy := 0		
		sbc	hl,bc
		jr	nc,zahl2
		add	hl,bc
		push	hl
		ex	de,hl
		dec	a
		jr	nz,zahl1
		ld	c,5
		ld	hl,datled+4
zahl3:		pop	de
		ld	a,e
		call	oneseg
		ld	(hl),a
		dec	hl
		dec	c
		jr	nz,zahl3
		ld	ix,datled
		call	dak1
;
		cp	a,0ah			; Eingabe neues X
		jr	nc,zahl6		; Jump, wenn Funktionstaste
		call	loanz
		ld	hl,datled+4
		ld	(marke),hl
		ld	hl,0
zahl5:		push	hl
		push	af
		ld	hl,(marke)
		call	oneseg
		ld	(hl),a
		dec	hl
		ld	(marke),hl
		pop	af
		pop	hl
		ld	e,a
		ld	d,0
		ld	b,10
		ex	de,hl
zahl7:		add	hl,de
		jr	c,zahlf
		djnz	zahl7
		push	hl
		ld	ix,datled
		call	dak1
		pop	hl
		cp	a,0ah
		jr	c,zahl5
		ex	(sp),hl
zahl6:		and	a
zahlf:		pop	hl
		pop	de
		ret
;
marke:		db 2 dup (?)
;	
loanz:		push	hl
		ld	b,6
		ld	hl,datled
ld1:		ld	(hl),0
		inc	hl
		djnz	ld1
		pop	hl
		ret
;
opausw:		push	hl			; Ermitteln UP-Adr.
		ld	hl,liste
		sub	0ah
		rlca
		ld	c,a
		ld	b,0
		add	hl,bc
		ld	c,(hl)
		inc	hl
		ld	b,(hl)
		push	bc
		pop	iy
		pop	hl
		ret
;		
liste:		dw	addw			; "A"
		dw	subw			; "B"
		dw	multw			; "C"
		dw	divw			; "D"
		dw	eingab			; "E"
		dw	frei			; "F"
;
tarech:		call	zahl			; Hauptprogrann
		jr	c,fehler
		call	opausw
		ld	bc,tare1
		push	bc
		jp	(iy)
tare1:		jr	nc,tarech
fehler:		push	hl			; Anzeige "ERROR"
		push	de
		ld	ix,txt_err
		call	dak1
		pop	de
		pop	hl
		jr	tarech
;
; 1. Operand in DE, 2. Operand in HL, Ergnis in HL
; bei Fehlern (unzulssige Operation) Cy = 1
;
addw:		add	hl,de			; 16bit-Addition
		ret
;
subw:		ex	de,hl			; 16bit-Subtraktion
		and	a
		sbc	hl,de
		ret
;
multw:		ld	b,h			; 16bit-Multiplikation
		ld	c,l
		ld	hl,0
multw1:		ld	a,b
		or	c
		ret	z
		dec	bc
		add	hl,de
		ret	c
		jr	multw1
;
divw:		ex	de,hl			; 16bit-Division
		ld	a,d
		or	e
		jr	z,divw0
		ld	bc,0ffffh
divw1:		inc	bc
		and	a
		sbc	hl,de
		jr	nc,divw1
		ld	h,b
		ld	l,c
		and	a
		ret
divw0:		scf
		ret
;
eingab:		ex	de,hl			; fr Eingabe einer neuen Ziffer
		and	a			; Cy = 0
		ret	
;
frei:		and	a			; Reservefunktion
		ret
;
;clear:		ld	hl,0
;		ld	de,0
;		jp	tarech
;
;frei:		ld	h,d			; "F" - Quadrat
;		ld	l,e
;		jp	mulw
		
		end

