; Programm E004
; Digitaluhr mit Melodie
; Autor: Volker Pohlers, nach Handbuch Beispiel 10
;
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h

ex10:		im	2
		ld	a,hi(inttab)		; Interrupttabelle H-Byte
		ld	i,a
		ld	a,lo(inttab)		; Interrupt-Vektor L-Byte
		out	CTC0,a
		ld	a,0a5h			; Int. Zeitgeber, X 256
		out	CTC0,a
		ld	a,0ech			; Zeitkonstante
		out	CTC0,a
m1:		ld	ix,DATLED		; Adr. Anzeigespeichers
		call	DAK2
		jr	c,m2			; Spr., wenn keine Taste
		xor	a
		ld	(wf),a			; Wecker lschen
m2:		ld	a,(wf)
		ld	iy,musik1		; oder musik2
		cp	55h
		call	z,music			; Wenn Weckzeit
		ei
		jr	m1

		org	2030h
;
; Interruptroutine
;
introut:	push	af
		push	bc
		push	de
		push	hl
		ld	hl,zwz			; Adr. Zeitwertspeicher
		ld	b,15h			; Grenzwert Takte
		call	inct			; Takte erhhen
		jr	nz,exit
		ld	b,60h			; Grenzwert Sekunde und Minute
		call	z,inct			; ggf. Sek. erhhen
		call	z,inct			; ggf. Min. erhhen
		ld	b,24h			; Grenzwert Stunden
		call	z,inct			; ggf. Stunden erhhen
		ld	a,(sek)
		call	dadp			; Sekunden anzeigen
m3:		ld	hl,(min)
		ex	de,hl
		call	adrsdp			; Min. und Std. anzeigen
m5:		ld	hl,(min)		; Test, ob Weckzeit
		ld	de,(weckmin)
		and	a			; Cy = 0
		sbc	hl,de
		jr	nz,m4
		ld	a,(sek)
		cp	a,0
		jr	nz,m4
		ld	a,55h			; Flag "Wecken" setzen
		ld	(wf),a
m4:		jr	nz,m5
exit:		ld	hl,ADRLED		; die Punkte zwischen
		set	4,(hl)			; Minute und Sekunde
		inc	hl
		inc	hl
		set	4,(hl)			; und Stunde und Minute
		pop	hl
		nop
		nop
		pop	hl
		pop	de
		pop	bc
		pop	af
		ei
		reti
;
inct:		ld	a,(hl)
		add	a,1
		daa
		ld	(hl),a
		sub	b
		jr	nz,m6
		ld	(hl),a
m6:		inc	hl
		ret
;
zwz:		db	?
sek:		db	?
min:		db	?
hour:		db	?
weckmin:	db	?
weckhour:	db	?
wf:		db	?
;
; Die Weckmusik
;
musik1:		db	02h,05h,06h,05h,09h,15h,06h,15h	; "Wachet auf"
		db	09h,05h,0eh,15h,20h,01h,0eh,09h
		db	0dh,10h,0bh,05h,00h,09h,0eh,10h
		db	20h,01h,0eh,09h,12h,10h,10h,05h
		db	0eh,09h,20h,01h,0eh,08h,09h,09h
		db	06h,09h,04h,09h,09h,09h,07h,09h
		db	06h,15h,80h

musik2:		db	0bh,08h,20h,01h,0bh		; "Fame"
		db	04h,00h,06h,0bh,06h,0eh,06h,10h
		db	06h,12h,06h,0bh,08h,20h,01h,0bh
		db	04h,0dh,06h,0bh,06h,0eh,06h,20h
		db	06h,12h,06h,20h,01h,10h,08h,20h
		db	01h,10h,04h,12h,06h,10h,06h,13h
		db	06h,15h,06h,17h,06h,20h,03h,80h


		org	2100h
;
; Interrupttabelle

inttab:		dw	introut
		end
