; Programm
; Logikspiel (Master Mind)
; Autor: Gunther Zielosko
; "Hinweise zur Anwendung des Lerncomputers LC 80", Teil 3, Seite 49-56
;------------------------------------------------------------------------------
; Mastermind
; 0..7, auch doppelt
; '+' - Start
; Eingabe Versuch -> Anzeige Versuch|Nr
; '+' Anzeige links Position, rechts Farbe (z.B. 0P|1F - 1 richtig, aber falsche Stelle)
; bei 4Ps -> Fanfare
; bel. Taste -> nchster Versuch
;------------------------------------------------------------------------------

		CPU Z80

		include	lc80

		org 2000h

; Speicherbereiche lschen
		ld	b,01fh
		ld	hl,2300h
		ld	a,0
m1:		ld	(hl),a
		inc	hl
		djnz	m1
; 2 Zufallsziffern eintragen
		ld	hl,2308h
		call	zufaz
; Laufschrift LOGICSPIEL
m2:		ld	c,0fh
		ld	ix,txt_logic
m3:		ld	b,10h
m4:		call	dak2
		cp	0ah			; Taste '+'
		jr	z,m5
		djnz	m4		
		dec	ix
		dec	c
		jr	nz,m3
		jr	m2
; 2 Zufallszahlen eintragen, Versuchsnr. auf 0 setzen
m5:		ld	hl,230ah
		call	zufaz
		ld	a,1
		ld	(230Ch),a
; Darstellen des Speicherbereiches Versuch und Versuchsnummer
m6:		ld	hl,2312h
		ld	ix,2306h
		call	anz
		call	dak1
		cp	10h			; Taste '+' ?
		jr	z,m7
		call	verpro
		jr	m6
; aktuelle Versuchsnummer aus 230ch holen, um 1 erhhen, Ergebnis BCD-
; korrigieren, untere 4 Bit auf 230ch, obere 4 Bit auf 230dh ablegen
m7:		call	vergl
		ld	a,(230ch)
		add	a,1
		daa
		ld	(230ch),a
		and	0f0h
		rrca
		rrca
		rrca
		rrca
		ld	(230dh),a
; "P" in 2316h eintragen
		ld	a,04fh
		ld	(2316h),a
; "F" in 2312h eintragen
		ld	a,04eh
		ld	(2312h),a
; F-Zahl in 7-Segment-Form in 2313h laden
		ld	a,(2306h)
		call	oneseg
		ld	(2313h),a
; P-Zahl in 7-Segment-Form in 2317h laden
		ld	a,(2307h)
		call	oneseg
		ld	(2317h),a
		cp	2bh			; Vergl. mit '4'
		jr	nz,m8
m9:		ld	ix,2312h
		call	dak1
		jp	m6
;
m8:		ld	iy,noten
		call	music
		jr	m9
;
; Text LOGICSPIEL als Laufschrift
		db	0,0
		db	000h,000h,0c2h,0ceh,021h,04fh	; 'PIEL  '
		db	0aeh,0c6h,021h,0e6h,0e7h,0c2h	; 'LOGICS'
txt_logic:	db	0,0,0,0,0,0
;		
; A mit 2 Hexa-Ziffern aus dem Refresh-Register laden, Bit 3 und 7 ausblenden
; und so umformen, da je eine Ziffer (0..7) in HL und HL+1 abgelegt wird.
zufaz:		ld	a,R
		and	77h
		rld
		rrca
		rrca
		rrca
		rrca
		inc	hl
		rld
		ret
;
; 6maliges Umformen der Tipzahlen und der Versuchsnummer in 7-Segment-Form,
; Vorbereiten der Anzeige. Setzten des Punktes in Digit 4
anz:		ld	b,6
m10:		dec	hl
		dec	ix
		ld	a,(hl)
		call	oneseg
		ld	(ix+0),a
		djnz	m10
		ld	hl,2302h
		set	4,(hl)
		ret
;
; Verschieben von 4 Tippziffern um eine Stelle
; letzte Ziffer in T4, T4->T3, T3->T2, T2-T1, T1 geht verloren
verpro:		ld	b,4
		ld	hl,230dh
m11:		inc	hl
		and	7
		rrd
		rr	(hl)
		rr	(hl)
		rr	(hl)
		rr	(hl)
		djnz	m11
		ret
;
vergl:		call	SOU1K			; Piepton (original: SOU1K+1)
		ld	a,0
		ld	(2306h),a		; P und F lschen
		ld	(2307h),a
; Positionsvergleich 
		ld	b,4			
		ld	de,230dh
		ld	hl,2307h
m12:		inc	de
		inc	hl			; (Z4)
		ld	a,(de)			; (T4)
		cp	(hl)			; T4 mit Z4 vergleichen
		jr	nz,m13
;
		ld	a,(2307h)		; P um 1 erhhen
		inc	a
		ld	(2307h),a
m13:		djnz	m12			; nchstes Z und T
; Doppel der Zufallszahl Z1 bis Z4 auf 231ah bis 231dh ablegen (Z1' bis Z4')
		ld	hl,2308h
		ld	de,231ah
		ld	bc,4
		ldir
; Farbvergleich
		ld	b,4
		ld	hl,230eh
m14:		ld	de,231ah
		ld	c,4
m15:		ld	a,(de)
		cp	(hl)			; T4 mit Z4' vergl.
		jr	nz,m16
;
		ld	a,(2306h)		; F um 1 erhhen
		inc	a
		ld	(2306h),a
		ld	a,0ffh			; Z4' mit 0FFh berschreiben
		ld	(de),a
		jr	m17
;
m16:		inc	de			; T4 mit Z3' vergl. usw.
		dec	c
		jr	nz,m15
;
m17:		inc	hl			; alles mit T3 wiederholen usw.
		djnz	m14
;
		ld	hl,2307h		; P in (HL)
		ld	a,(2306h)		; Fneu = F-P in 2306h laden
		sub	(HL)
		ld	(2306h),a
		ret
;
noten:		db	0bh,04h
		db	0fh,04h
		db	12h,04h
		db	17h,10h
		db	80h		

;; Anzeigebereich 1. Versuch und Versuchnr. in 7-Segment-Code
;2305	T1
;2304	T2
;2303	T3
;2302	T4
;2301	V(10)
;2300	V(1)
;; 
;230b	Z1	Z1-Z4: Zufallsziffern
;230a	Z2
;2309	Z3
;2308	Z4
;2307	P	P: Anzahl der richtigen Positionen
;2306	F	F: Anzahl der richtigen "Farben"
;;
;2311	T1	T1-T4: aktueller Tip
;2310	T2
;230F	T3
;230E	T4
;230D	V(10)	V: Nr. des Versuches
;230C	V(1)
;; Anzeigenbreich 2
;2317	P	P: Zahl im 7-Segment-Code
;2316	'P'
;2315
;2314	
;2312	F	F: Zahl im 7-Segment-Code
;2311	'F'
;;
;231D	Z1'	Z1'-Z4': Doppel von Z1-Z4 zum Vergleich
;231C	Z2'
;231B	Z3'
;231A	Z4'
		
		end